## ros-melodic-behaviortree-cpp-v3 3.5.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1) # version on Ubuntu Xenial
project(behaviortree_cpp_v3)

#---- Add the subdirectory cmake ----
set(CMAKE_CONFIG_PATH ${CMAKE_MODULE_PATH}  "${CMAKE_CURRENT_LIST_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CONFIG_PATH}")

#---- Enable C++14 ----
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

#---- Include boost to add coroutines ----
find_package(Boost COMPONENTS coroutine QUIET)
if(Boost_FOUND)
    include_directories(${Boost_INCLUDE_DIRS})
    string(REPLACE "." "0" Boost_VERSION_NODOT ${Boost_VERSION})
    if(NOT Boost_VERSION_NODOT VERSION_LESS 105900)
        message(STATUS "Found boost::coroutine2.")
        add_definitions(-DBT_BOOST_COROUTINE2)
        set(BT_COROUTINES true)
    elseif(NOT Boost_VERSION_NODOT VERSION_LESS 105300)
        message(STATUS "Found boost::coroutine.")
        include_directories(${Boost_INCLUDE_DIRS})
        add_definitions(-DBT_BOOST_COROUTINE)
        set(BT_COROUTINES true)
    endif()
endif()

if(NOT DEFINED BT_COROUTINES)
    message(STATUS "Coroutines disabled. Install Boost to enable them (version 1.59+ recommended).")
    add_definitions(-DBT_NO_COROUTINES)
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

#---- project configuration ----
option(BUILD_EXAMPLES   "Build tutorials and examples" ON)
option(BUILD_UNIT_TESTS "Build the unit tests" ON)
option(BUILD_TOOLS "Build commandline tools" ON)
option(BUILD_SHARED_LIBS "Build shared libraries" ON)

#---- Find other packages ----
find_package(Threads)
find_package(ZMQ)

list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES
    ${CMAKE_THREAD_LIBS_INIT}
    ${CMAKE_DL_LIBS}
    ${Boost_LIBRARIES} )

if( ZMQ_FOUND )
    message(STATUS "ZeroMQ found.")
    add_definitions( -DZMQ_FOUND )
    list(APPEND BT_SOURCE src/loggers/bt_zmq_publisher.cpp)
    list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES ${ZMQ_LIBRARIES})
else()
    message(WARNING "ZeroMQ NOT found. Skipping the build of [PublisherZMQ] and [bt_recorder].")
endif()

set(BEHAVIOR_TREE_LIBRARY ${PROJECT_NAME})

# Update the policy setting to avoid an error when loading the ament_cmake package
# at the current cmake version level
if(POLICY CMP0057)
    cmake_policy(SET CMP0057 NEW)
endif()

find_package(ament_cmake QUIET)

if ( ament_cmake_FOUND )

    # Not adding -DUSING_ROS since xml_parsing.cpp hasn't been ported to ROS2

    message(STATUS "------------------------------------------")
    message(STATUS "BehaviourTree is being built using AMENT.")
    message(STATUS "------------------------------------------")

    set(BUILD_TOOL_INCLUDE_DIRS ${ament_INCLUDE_DIRS})

elseif( CATKIN_DEVEL_PREFIX OR CATKIN_BUILD_BINARY_PACKAGE)

    set(catkin_FOUND 1)
    add_definitions( -DUSING_ROS )
    find_package(catkin REQUIRED COMPONENTS roslib)
    find_package(GTest)

    message(STATUS "------------------------------------------")
    message(STATUS "BehaviourTree is being built using CATKIN.")
    message(STATUS "------------------------------------------")

    catkin_package(
        INCLUDE_DIRS include # do not include "3rdparty" here
        LIBRARIES ${BEHAVIOR_TREE_LIBRARY}
        CATKIN_DEPENDS roslib
        )

    list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES ${catkin_LIBRARIES})
    set(BUILD_TOOL_INCLUDE_DIRS ${catkin_INCLUDE_DIRS})

elseif(BUILD_UNIT_TESTS)
    find_package(GTest REQUIRED)
endif()


#############################################################
if(ament_cmake_FOUND)
    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )

    ament_export_include_directories(include)
    ament_export_libraries(${BEHAVIOR_TREE_LIBRARY})
    ament_package()
elseif(catkin_FOUND)
    set( BEHAVIOR_TREE_LIB_DESTINATION   ${CATKIN_PACKAGE_LIB_DESTINATION} )
    set( BEHAVIOR_TREE_INC_DESTINATION   ${CATKIN_GLOBAL_INCLUDE_DESTINATION} )
    set( BEHAVIOR_TREE_BIN_DESTINATION   ${CATKIN_GLOBAL_BIN_DESTINATION} )
else()
    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )

    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${BEHAVIOR_TREE_BIN_DESTINATION}" )
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${BEHAVIOR_TREE_LIB_DESTINATION}" )
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${BEHAVIOR_TREE_BIN_DESTINATION}" )
endif()

message( STATUS "BEHAVIOR_TREE_LIB_DESTINATION:   ${BEHAVIOR_TREE_LIB_DESTINATION} " )
message( STATUS "BEHAVIOR_TREE_BIN_DESTINATION:   ${BEHAVIOR_TREE_BIN_DESTINATION} " )
message( STATUS "CMAKE_RUNTIME_OUTPUT_DIRECTORY:  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY} " )
message( STATUS "CMAKE_LIBRARY_OUTPUT_DIRECTORY:  ${CMAKE_LIBRARY_OUTPUT_DIRECTORY} " )
message( STATUS "CMAKE_ARCHIVE_OUTPUT_DIRECTORY:  ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY} " )

#############################################################
# LIBRARY

list(APPEND BT_SOURCE
    src/action_node.cpp
    src/basic_types.cpp
    src/behavior_tree.cpp
    src/blackboard.cpp
    src/bt_factory.cpp
    src/decorator_node.cpp
    src/condition_node.cpp
    src/control_node.cpp
    src/shared_library.cpp
    src/tree_node.cpp
    src/xml_parsing.cpp

    src/decorators/inverter_node.cpp
    src/decorators/repeat_node.cpp
    src/decorators/retry_node.cpp
    src/decorators/subtree_node.cpp
    src/decorators/delay_node.cpp

    src/controls/if_then_else_node.cpp
    src/controls/fallback_node.cpp
    src/controls/parallel_node.cpp
    src/controls/reactive_sequence.cpp
    src/controls/reactive_fallback.cpp
    src/controls/sequence_node.cpp
    src/controls/sequence_star_node.cpp
    src/controls/switch_node.cpp
    src/controls/while_do_else_node.cpp

    src/loggers/bt_cout_logger.cpp
    src/loggers/bt_file_logger.cpp
    src/loggers/bt_minitrace_logger.cpp
    src/private/tinyxml2.cpp

    3rdparty/minitrace/minitrace.cpp
    )

find_package(Curses QUIET)

if(CURSES_FOUND)
    list(APPEND BT_SOURCE
        src/controls/manual_node.cpp
        )
    list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES ${CURSES_LIBRARIES})
    add_definitions(-DNCURSES_FOUND)
endif()


######################################################

if (UNIX)
    list(APPEND BT_SOURCE src/shared_library_UNIX.cpp )
    if (BUILD_SHARED_LIBS)
        add_library(${BEHAVIOR_TREE_LIBRARY} SHARED ${BT_SOURCE})
    else()
        add_library(${BEHAVIOR_TREE_LIBRARY} STATIC ${BT_SOURCE})
    endif()
endif()

if (WIN32)
    set(CMAKE_DEBUG_POSTFIX "d")
    list(APPEND BT_SOURCE src/shared_library_WIN.cpp )
    add_library(${BEHAVIOR_TREE_LIBRARY} STATIC ${BT_SOURCE} )
endif()

if( ZMQ_FOUND )
    list(APPEND BUILD_TOOL_INCLUDE_DIRS ${ZMQ_INCLUDE_DIRS})
endif()

target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PUBLIC
    ${BEHAVIOR_TREE_EXTERNAL_LIBRARIES})

target_compile_definitions(${BEHAVIOR_TREE_LIBRARY} PRIVATE $<$<CONFIG:Debug>:TINYXML2_DEBUG>)

target_include_directories(${BEHAVIOR_TREE_LIBRARY} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    ${BUILD_TOOL_INCLUDE_DIRS})

if( ZMQ_FOUND )
    target_compile_definitions(${BEHAVIOR_TREE_LIBRARY} PUBLIC ZMQ_FOUND)
endif()

if(MSVC)
    target_compile_options(${BEHAVIOR_TREE_LIBRARY} PRIVATE /W3 /WX)
else()
    target_compile_options(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        -Wall -Wextra -Werror=return-type)
endif()

######################################################
# Test
if (BUILD_UNIT_TESTS)
    add_subdirectory(tests)
endif()

######################################################
# INSTALL

INSTALL(TARGETS ${BEHAVIOR_TREE_LIBRARY}
    EXPORT BehaviorTreeV3Config
    ARCHIVE DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
    LIBRARY DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
    RUNTIME DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION}
    )

INSTALL( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/
    DESTINATION ${BEHAVIOR_TREE_INC_DESTINATION}
    FILES_MATCHING PATTERN "*.h*")

install(EXPORT BehaviorTreeV3Config
    DESTINATION "${BEHAVIOR_TREE_LIB_DESTINATION}/BehaviorTreeV3/cmake"
    NAMESPACE BT::)

export(TARGETS ${PROJECT_NAME}
    NAMESPACE BT::
    FILE "${CMAKE_CURRENT_BINARY_DIR}/BehaviorTreeV3Config.cmake")

export(PACKAGE ${PROJECT_NAME})

######################################################
# EXAMPLES and TOOLS
if(BUILD_TOOLS)
    add_subdirectory(tools)
endif()

if( BUILD_EXAMPLES )
    add_subdirectory(sample_nodes)
    add_subdirectory(examples)
endif()

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)

include_directories( ../sample_nodes )

set(CMAKE_DEBUG_POSTFIX "")

# The plugin libdummy_nodes.so can be linked statically or
# loaded dynamically at run-time.
add_executable(t01_first_tree_static  t01_build_your_first_tree.cpp )
target_compile_definitions(t01_first_tree_static PRIVATE "MANUAL_STATIC_LINKING")
target_link_libraries(t01_first_tree_static ${BEHAVIOR_TREE_LIBRARY}   bt_sample_nodes )

add_executable(t01_first_tree_dynamic  t01_build_your_first_tree.cpp )
target_link_libraries(t01_first_tree_dynamic ${BEHAVIOR_TREE_LIBRARY}  )


add_executable(t02_basic_ports  t02_basic_ports.cpp )
target_link_libraries(t02_basic_ports ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )

add_executable(t03_generic_ports        t03_generic_ports.cpp )
target_link_libraries(t03_generic_ports ${BEHAVIOR_TREE_LIBRARY}  bt_sample_nodes  )

add_executable(t04_reactive_sequence         t04_reactive_sequence.cpp )
target_link_libraries(t04_reactive_sequence  ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes  )

add_executable(t05_cross_door         t05_crossdoor.cpp )
target_link_libraries(t05_cross_door   ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )

add_executable(t06_subtree_port_remapping  t06_subtree_port_remapping.cpp )
target_link_libraries(t06_subtree_port_remapping ${BEHAVIOR_TREE_LIBRARY}   bt_sample_nodes )

add_executable(t07_wrap_legacy         t07_wrap_legacy.cpp )
target_link_libraries(t07_wrap_legacy   ${BEHAVIOR_TREE_LIBRARY} )

add_executable(t08_additional_node_args   t08_additional_node_args.cpp )
target_link_libraries(t08_additional_node_args   ${BEHAVIOR_TREE_LIBRARY} )

if (BT_COROUTINES)
    add_executable(t09_async_actions_coroutines  t09_async_actions_coroutines.cpp )
    target_link_libraries(t09_async_actions_coroutines ${BEHAVIOR_TREE_LIBRARY} )
endif()

add_executable(t10_include_trees  t10_include_trees.cpp )
target_link_libraries(t10_include_trees  ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )


add_executable(t11_runtime_ports  t11_runtime_ports.cpp )
target_link_libraries(t11_runtime_ports  ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )

if(CURSES_FOUND)
    add_executable(t12_ncurses_manual_selector  t12_ncurses_manual_selector.cpp )
    target_link_libraries(t12_ncurses_manual_selector  ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )
endif()

=== tests/CMakeLists.txt ===
######################################################
# TESTS

include_directories(include)

set(BT_TESTS
  src/action_test_node.cpp
  src/condition_test_node.cpp
  gtest_tree.cpp
  gtest_sequence.cpp
  gtest_parallel.cpp
  gtest_fallback.cpp
  gtest_factory.cpp
  gtest_decorator.cpp
  gtest_blackboard.cpp
  gtest_ports.cpp
  navigation_test.cpp
  gtest_subtree.cpp
  gtest_switch.cpp
)

if (BT_COROUTINES)
    list(APPEND BT_TESTS  gtest_coroutines.cpp)
endif()

if(ament_cmake_FOUND AND BUILD_TESTING)

    find_package(ament_cmake_gtest REQUIRED)

    ament_add_gtest_executable(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
    target_link_libraries(${BEHAVIOR_TREE_LIBRARY}_test ${BEHAVIOR_TREE_LIBRARY}
                                                        bt_sample_nodes
                                                        ${ament_LIBRARIES})
    target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include)
    include_directories($<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty>)

elseif(catkin_FOUND AND CATKIN_ENABLE_TESTING)

    catkin_add_gtest(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
    target_link_libraries(${BEHAVIOR_TREE_LIBRARY}_test ${BEHAVIOR_TREE_LIBRARY}
                                                        bt_sample_nodes
                                                        ${catkin_LIBRARIES})
    target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include)

elseif(GTEST_FOUND AND BUILD_UNIT_TESTS)

    enable_testing()

    add_executable(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
    target_link_libraries(${PROJECT_NAME}_test ${BEHAVIOR_TREE_LIBRARY}
                                                bt_sample_nodes
                                                ${GTEST_LIBRARIES}
                                                ${GTEST_MAIN_LIBRARIES})
    target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include ${GTEST_INCLUDE_DIRS})

    add_test(BehaviorTreeCoreTest ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${BEHAVIOR_TREE_LIBRARY}_test)

endif()

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)


add_executable(bt3_log_cat         bt_log_cat.cpp )
target_link_libraries(bt3_log_cat  ${BEHAVIOR_TREE_LIBRARY} )
install(TARGETS bt3_log_cat
        DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )

if( ZMQ_FOUND )
    add_executable(bt3_recorder         bt_recorder.cpp )
    target_link_libraries(bt3_recorder  ${BEHAVIOR_TREE_LIBRARY} )
    install(TARGETS bt3_recorder
            DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )
endif()

add_executable(bt3_plugin_manifest         bt_plugin_manifest.cpp )
target_link_libraries(bt3_plugin_manifest  ${BEHAVIOR_TREE_LIBRARY} )
install(TARGETS bt3_plugin_manifest
        DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )

=== debian/changelog ===
ros-melodic-behaviortree-cpp-v3 (3.5.3-1stretch) stretch; urgency=high

  * fix issue #228 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/228> . Retry and Repeat node need to halt the child
  * better tutorial
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 09 Sep 2020 22:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.5.2-1stretch) stretch; urgency=high

  * fix warning and follow coding standard
  * docs: Small changes to tutorial 02 (#225 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/225>)
    Co-authored-by: Valerio Magnago <mailto:valerio.magnago@fraunhofer.it>
  * Merge branch 'master' of https://github.com/BehaviorTree/BehaviorTree.CPP
  * tutorial 1 fixed
  * decreasing warning level to fix issue #220 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/220>
  * fix compilation
  * Allow BT factory to define clock source for TimerQueue/TimerNode (#215 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/215>)
    * Allow BT factory to define clock source for TimerQueue/TimerNode
    * Fix unit tests
    Co-authored-by: Cam Fulton <mailto:cfulton@symbotic.com>
    Co-authored-by: Davide Faconti <mailto:davide.faconti@gmail.com>
  * Added delay node and wait for enter keypress node (#182 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/182>)
    * Added delay node and wait for enter press node
    * Fixed unsigned int to int conversion bug
    * Added a new timer to keep a track of delay timeout and return RUNNING in the meanwhile
    * Removed wait for keypress node
    * Review changes suggested by gramss
    Co-authored-by: Indraneel Patil <mailto:indraneel.p@greyorange.com>
  * Update SequenceNode.md (#211 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/211>)
  * add failure threshold to parallel node with tests (#216 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/216>)
  * Update tutorial_05_subtrees.md
    I believe that the API has been updated. Reflecting the same in this tutorial.
  * Contributors: Aayush Naik, Davide Faconti, Indraneel Patil, Renan Salles, Valerio Magnago, Wuqiqi123, fultoncjb

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 01 Sep 2020 22:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.5.1-1stretch) stretch; urgency=high

  * trying to fix compilation in eloquent  Minor fix on line 19
  * Update README.md
  * more badges
  * readme updated
  * fix ros2 compilation?
  * move to github actions
  * replace dot by zero in boost version (#197 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/197>)
  * Always use nonstd::string_view for binary compatibility (fix issue #200 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/200>)
  * Adding ForceRunningNode Decorator (#192 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/192>)
  * updated doc
  * Add XML parsing support for custom Control Nodes (#194 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/194>)
  * Fix typo
  * [Windows] Compare std::type_info objects to check type. (#181 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/181>)
  * Fix pseudocode for ReactiveFallback. (#191 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/191>)
  * Contributors: Aayush Naik, Darío Hereñú, Davide Faconti, Francisco Martín Rico, G.Doisy, Sarathkrishnan Ramesh, Sean Yen, Ting Chang

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 10 Jun 2020 22:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.5.0-1stretch) stretch; urgency=high

  * added IfThenElse and  WhileDoElse
  * issue #190 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/190>
  * unit test added
  * reverting to a better solution
  * RemappedSubTree added
  * Fix issue #188 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/188>
  * added function const std::string& key (issue #183 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/183>)
  * Contributors: Davide Faconti, mailto:daf@blue-ocean-robotics.com
  * added IfThenElse and  WhileDoElse
  * issue #190 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/190>
  * unit test added
  * reverting to a better solution
  * RemappedSubTree added
  * Fix issue #188 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/188>
  * added function const std::string& key (issue #183 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/183>)
  * Contributors: Davide Faconti, mailto:daf@blue-ocean-robotics.com

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 13 May 2020 22:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.1.1-1stretch) stretch; urgency=high

  * fix samples compilation (hopefully)
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 09 Nov 2019 23:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.1.0-1stretch) stretch; urgency=high

  * Error message corrected
  * fix windows and mingw compilation (?)
  * Merge pull request #70 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/70> from Masadow/patch-3
    Added 32bits compilation configuration for msvc
  * make Tree non copyable
  * fix #114 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/114>
  * Merge branch 'master' of https://github.com/BehaviorTree/BehaviorTree.CPP
  * critical bug fix affecting AsyncActionNode
    When a Tree is copied, all the thread related to AsyncActionNode where
    invoked.
    As a consequence, they are never executed, despite the fact that the
    value RUNNING is returned.
  * Fix issue #109 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/109>
  * fix #111 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/111>
  * Merge pull request #108 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/108> from daniel-serrano/add-RobMoSys-acknowledgement
    Add robmosys acknowledgement
  * Add robomosys acknowledgement as requested
  * Add robomosys acknowledgement as requested
  * added more comments (issue #102 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/102>)
  * Update README.md


=== debian/control ===
Source: ros-melodic-behaviortree-cpp-v3
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libncurses5-dev, libzmq3-dev, ros-melodic-catkin, ros-melodic-roslib
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-behaviortree-cpp-v3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libncurses5-dev, libzmq3-dev, ros-melodic-roslib
Description: This package provides the Behavior Trees core library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-behaviortree-cpp-v3//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-behaviortree-cpp-v3 3.8.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2) # version on Ubuntu Bionic
project(behaviortree_cpp_v3)

#---- Add the subdirectory cmake ----
set(CMAKE_CONFIG_PATH ${CMAKE_MODULE_PATH}  "${CMAKE_CURRENT_LIST_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CONFIG_PATH}")

#---- Enable C++14 ----
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -DWIN32_LEAN_AND_MEAN)
else()
    add_definitions(-Wpedantic)
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

#---- project configuration ----
option(BUILD_EXAMPLES   "Build tutorials and examples" ON)
option(BUILD_UNIT_TESTS "Build the unit tests" ON)
option(BUILD_TOOLS "Build commandline tools" ON)
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(BUILD_MANUAL_SELECTOR "Build manual selector node" ON)
option(ENABLE_COROUTINES "Enable boost coroutines" ON)

#---- Include boost to add coroutines ----
if(ENABLE_COROUTINES)
    find_package(Boost COMPONENTS coroutine QUIET)

    if(Boost_FOUND)
        string(REPLACE "." "0" Boost_VERSION_NODOT ${Boost_VERSION})
        if(NOT Boost_VERSION_NODOT VERSION_LESS 105900)
            message(STATUS "Found boost::coroutine2.")
            add_definitions(-DBT_BOOST_COROUTINE2)
            set(BT_COROUTINES_FOUND true)
        elseif(NOT Boost_VERSION_NODOT VERSION_LESS 105300)
            message(STATUS "Found boost::coroutine.")
            add_definitions(-DBT_BOOST_COROUTINE)
            set(BT_COROUTINES_FOUND true)
        endif()
    endif()

    if(NOT DEFINED BT_COROUTINES_FOUND)
        message(STATUS "Boost coroutines disabled. Install Boost (version 1.59+ recommended).")
    endif()
else()
    message(STATUS "Boost coroutines disabled by CMake option.")
endif()

if(NOT DEFINED BT_COROUTINES_FOUND)
    add_definitions(-DBT_NO_COROUTINES)
endif()

#---- Find other packages ----
find_package(Threads)
find_package(ZMQ)

if( ZMQ_FOUND )
    message(STATUS "ZeroMQ: found.")
    add_definitions( -DZMQ_FOUND )
    list(APPEND BT_SOURCE src/loggers/bt_zmq_publisher.cpp)
else()
    message(WARNING "ZeroMQ NOT found. Skipping the build of [PublisherZMQ] and [bt_recorder].")
endif()

set(BEHAVIOR_TREE_LIBRARY ${PROJECT_NAME})

# Update the policy setting to avoid an error when loading the ament_cmake package
# at the current cmake version level
if(POLICY CMP0057)
    cmake_policy(SET CMP0057 NEW)
endif()

find_package(ament_cmake QUIET)

if ( ament_cmake_FOUND )

    add_definitions( -DUSING_ROS2 )
    message(STATUS "------------------------------------------")
    message(STATUS "BehaviourTree is being built using AMENT.")
    message(STATUS "------------------------------------------")

elseif( CATKIN_DEVEL_PREFIX OR CATKIN_BUILD_BINARY_PACKAGE)

    set(catkin_FOUND 1)
    add_definitions( -DUSING_ROS )
    find_package(catkin REQUIRED COMPONENTS roslib)
    find_package(GTest)

    message(STATUS "------------------------------------------")
    message(STATUS "BehaviourTree is being built using CATKIN.")
    message(STATUS "------------------------------------------")

    catkin_package(
        INCLUDE_DIRS include # do not include "3rdparty" here
        LIBRARIES ${BEHAVIOR_TREE_LIBRARY}
        CATKIN_DEPENDS roslib
        )

elseif(BUILD_UNIT_TESTS)
    if(${CMAKE_VERSION} VERSION_LESS "3.11.0")
        find_package(GTest REQUIRED)
    else()
        include(FetchContent)
        FetchContent_Declare(
            googletest
            URL https://github.com/google/googletest/archive/609281088cfefc76f9d0ce82e1ff6c30cc3591e5.zip
            )
        # For Windows: Prevent overriding the parent project's compiler/linker settings
        set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
        FetchContent_MakeAvailable(googletest)
    endif()
endif()


#############################################################
# LIBRARY

list(APPEND BT_SOURCE
    src/action_node.cpp
    src/basic_types.cpp
    src/behavior_tree.cpp
    src/blackboard.cpp
    src/bt_factory.cpp
    src/decorator_node.cpp
    src/condition_node.cpp
    src/control_node.cpp
    src/shared_library.cpp
    src/tree_node.cpp
    src/xml_parsing.cpp

    src/decorators/inverter_node.cpp
    src/decorators/repeat_node.cpp
    src/decorators/retry_node.cpp
    src/decorators/subtree_node.cpp
    src/decorators/delay_node.cpp

    src/controls/if_then_else_node.cpp
    src/controls/fallback_node.cpp
    src/controls/parallel_node.cpp
    src/controls/reactive_sequence.cpp
    src/controls/reactive_fallback.cpp
    src/controls/sequence_node.cpp
    src/controls/sequence_star_node.cpp
    src/controls/switch_node.cpp
    src/controls/while_do_else_node.cpp

    src/loggers/bt_cout_logger.cpp
    src/loggers/bt_file_logger.cpp
    src/loggers/bt_minitrace_logger.cpp

    3rdparty/tinyxml2/tinyxml2.cpp
    3rdparty/minitrace/minitrace.cpp
    )

if(BUILD_MANUAL_SELECTOR)
    find_package(Curses QUIET)
    if(CURSES_FOUND)
        message(STATUS "NCurses: found.")
        list(APPEND BT_SOURCE src/controls/manual_node.cpp )
    else()
        message(WARNING "NCurses NOT found. Skipping the build of manual selector node.")
    endif()
endif()


######################################################

if (UNIX)
    list(APPEND BT_SOURCE src/shared_library_UNIX.cpp )
endif()

if (WIN32)
    set(CMAKE_DEBUG_POSTFIX "d")
    list(APPEND BT_SOURCE src/shared_library_WIN.cpp )
endif()

if (BUILD_SHARED_LIBS)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    add_library(${BEHAVIOR_TREE_LIBRARY} SHARED ${BT_SOURCE})
else()
    add_library(${BEHAVIOR_TREE_LIBRARY} STATIC ${BT_SOURCE})
endif()

target_link_libraries(${BEHAVIOR_TREE_LIBRARY}
    PUBLIC
        ${CMAKE_THREAD_LIBS_INIT}
        ${CMAKE_DL_LIBS}
)

target_include_directories(${BEHAVIOR_TREE_LIBRARY}
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
    PRIVATE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/lexy/include>
        $<BUILD_INTERFACE:${BTCPP_EXTRA_INCLUDE_DIRS}>
    )

if(ZMQ_FOUND)
    target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        ${ZMQ_LIBRARIES} )
    target_include_directories(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        ${ZMQ_INCLUDE_DIRS} )
    target_compile_definitions(${BEHAVIOR_TREE_LIBRARY} PRIVATE ZMQ_FOUND)
endif()

if(BT_COROUTINES_FOUND)
    target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        ${Boost_LIBRARIES} )
    target_include_directories(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        ${Boost_INCLUDE_DIRS} )
endif()

if(CURSES_FOUND)
    target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        ${CURSES_LIBRARIES} )
    target_include_directories(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        ${CURSES_INCLUDE_DIRS} )
    target_compile_definitions(${BEHAVIOR_TREE_LIBRARY} PRIVATE NCURSES_FOUND)
endif()


target_compile_definitions(${BEHAVIOR_TREE_LIBRARY} PRIVATE $<$<CONFIG:Debug>:TINYXML2_DEBUG>)

if(MSVC)
else()
    target_compile_options(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        -Wall -Wextra -Werror=return-type)
endif()

#############################################################
if(ament_cmake_FOUND)
    find_package(ament_index_cpp REQUIRED)

    target_include_directories(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        $<BUILD_INTERFACE:${ament_index_cpp_INCLUDE_DIRS}> )

    target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        $<BUILD_INTERFACE:ament_index_cpp::ament_index_cpp> )

    ament_export_dependencies(ament_index_cpp)

    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )

    ament_export_include_directories(include)
    ament_export_libraries(${BEHAVIOR_TREE_LIBRARY})
    ament_package()
elseif(catkin_FOUND)

    target_include_directories(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        ${catkin_INCLUDE_DIRS} )

    target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        ${catkin_LIBRARIES} )

    set( BEHAVIOR_TREE_LIB_DESTINATION   ${CATKIN_PACKAGE_LIB_DESTINATION} )
    set( BEHAVIOR_TREE_INC_DESTINATION   ${CATKIN_GLOBAL_INCLUDE_DESTINATION} )
    set( BEHAVIOR_TREE_BIN_DESTINATION   ${CATKIN_GLOBAL_BIN_DESTINATION} )

else()
    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )

endif()

message( STATUS "BEHAVIOR_TREE_LIB_DESTINATION:   ${BEHAVIOR_TREE_LIB_DESTINATION} " )
message( STATUS "BEHAVIOR_TREE_BIN_DESTINATION:   ${BEHAVIOR_TREE_BIN_DESTINATION} " )
message( STATUS "BUILD_UNIT_TESTS:   ${BUILD_UNIT_TESTS} " )

add_subdirectory(sample_nodes)

######################################################
# Test
if (BUILD_UNIT_TESTS)
    add_subdirectory(tests)
endif()

######################################################
# INSTALL

INSTALL( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/
    DESTINATION ${BEHAVIOR_TREE_INC_DESTINATION}
    FILES_MATCHING PATTERN "*.h*")

if(catkin_FOUND)
    INSTALL(TARGETS ${BEHAVIOR_TREE_LIBRARY}
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
    )
else()
    INSTALL(TARGETS ${BEHAVIOR_TREE_LIBRARY}
        EXPORT ${PROJECT_NAME}Targets
        ARCHIVE DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
        LIBRARY DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
        RUNTIME DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION}
    )

    install(EXPORT ${PROJECT_NAME}Targets
        FILE "${PROJECT_NAME}Targets.cmake"
        DESTINATION "${BEHAVIOR_TREE_LIB_DESTINATION}/cmake/${PROJECT_NAME}"
        NAMESPACE BT::
    )

    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
        DESTINATION "${BEHAVIOR_TREE_LIB_DESTINATION}/cmake/${PROJECT_NAME}"
    )

    export(PACKAGE ${PROJECT_NAME})

    include(CMakePackageConfigHelpers)

    configure_package_config_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Config.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
        INSTALL_DESTINATION "${BEHAVIOR_TREE_LIB_DESTINATION}/cmake/${PROJECT_NAME}"
    )
endif()


######################################################
# EXAMPLES and TOOLS
if(BUILD_TOOLS)
    add_subdirectory(tools)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 ######################################################
 # TESTS
 
-include_directories(include)
+include_directories(${PROJECT_SOURCE_DIR}/3rdparty include)
 
 set(BT_TESTS
   src/action_test_node.cpp
@@ -13,15 +13,27 @@
   gtest_factory.cpp
   gtest_decorator.cpp
   gtest_blackboard.cpp
+  gtest_blackboard_precondition.cpp
   gtest_ports.cpp
   navigation_test.cpp
   gtest_subtree.cpp
   gtest_switch.cpp
+  gtest_wakeup.cpp
 )
 
-if (BT_COROUTINES)
-    list(APPEND BT_TESTS  gtest_coroutines.cpp)
+if( ZMQ_FOUND )
+    LIST( APPEND BT_TESTS gtest_logger_zmq.cpp)
 endif()
+
+if( BT_COROUTINES )
+    LIST( APPEND BT_TESTS gtest_coroutines.cpp)
+endif()
+
+#if(ament_cmake_FOUND OR catkin_FOUND)
+#    # This test requires gmock. Since we don't have a uniform way to include
+#    # gmock for non-users, it is turned of when build without ros.
+#    list(APPEND BT_TESTS gtest_async_action_node.cpp)
+#endif()
 
 if(ament_cmake_FOUND AND BUILD_TESTING)
 
@@ -42,17 +54,20 @@
                                                         ${catkin_LIBRARIES})
     target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include)
 
-elseif(GTEST_FOUND AND BUILD_UNIT_TESTS)
+elseif(BUILD_UNIT_TESTS)
 
     enable_testing()
 
     add_executable(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
     target_link_libraries(${PROJECT_NAME}_test ${BEHAVIOR_TREE_LIBRARY}
-                                                bt_sample_nodes
-                                                ${GTEST_LIBRARIES}
-                                                ${GTEST_MAIN_LIBRARIES})
+                                                bt_sample_nodes gtest gtest_main)
     target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include ${GTEST_INCLUDE_DIRS})
 
-    add_test(BehaviorTreeCoreTest ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${BEHAVIOR_TREE_LIBRARY}_test)
+    add_custom_command(TARGET ${BEHAVIOR_TREE_LIBRARY}_test POST_BUILD
+        COMMAND ${CMAKE_COMMAND} -E copy_directory
+            ${CMAKE_SOURCE_DIR}/tests/trees
+            trees)
+
+    add_test(BehaviorTreeCoreTest ${BEHAVIOR_TREE_LIBRARY}_test)
 
 endif()

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.5)
 
+include_directories(${PROJECT_SOURCE_DIR}/3rdparty)
 
 add_executable(bt3_log_cat         bt_log_cat.cpp )
 target_link_libraries(bt3_log_cat  ${BEHAVIOR_TREE_LIBRARY} )
@@ -8,7 +9,7 @@
 
 if( ZMQ_FOUND )
     add_executable(bt3_recorder         bt_recorder.cpp )
-    target_link_libraries(bt3_recorder  ${BEHAVIOR_TREE_LIBRARY} )
+    target_link_libraries(bt3_recorder  ${BEHAVIOR_TREE_LIBRARY} ${ZMQ_LIBRARIES})
     install(TARGETS bt3_recorder
             DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )
 endif()

=== debian/changelog ===
ros-melodic-behaviortree-cpp-v3 (3.8.3-1bionic) bionic; urgency=high

  * fix and warnings added
  * fix in SharedLibrary and cosmetic changes to the code
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 28 Feb 2023 23:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.8.2-1bionic) bionic; urgency=high

  * rebane haltChildren to resetChildren
  * revert #329 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/329>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 04 Jan 2023 23:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.8.1-1bionic) bionic; urgency=high

  * fix catkin installation #478 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/478>
  * cherry picking changes from v4
  * fix #227 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/227>
  * fix issue #461 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/461>
  * fix issue #413 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/413> (Delay logic)
  * Update README.md
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 26 Nov 2022 23:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.8.0-1bionic) bionic; urgency=high

  * tickRootWhileRunning method
  * Fix: PublisherZMQ::flush is called after the publisher has been destructed (#426 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/426>)
    * fix: PublisherZMQ::flush is called after the publisher has been destructed
    * style: Adjust code formatting of ~PublisherZMQ
    * chore: Install zmq-dev in ubuntu pipeline and exclude gtest_logger_zmq.cpp when zmq is not found.
    * chore: Define WIN32_LEAN_AND_MEAN to avoid ambiguity between tinyxml and msxml
  * fix missing closing brace in unit test (#442 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/442>)
  * Fix incorrect registration of behavior trees containing faulty XML (#438 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/438>)
    * fix incorrect registration of faulty trees
    * format
    * simplify XML validation
    * fix possible out-of-range exception in tests
    * Add tests
    * reduce scale of diffs
    * fix comment
    * add more test cases
    Co-authored-by: Davide Faconti <mailto:davide.faconti@gmail.com>
  * Add functionality to clear registered behavior trees. (#439 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/439>)
    Co-authored-by: Jere Liukkonen <mailto:jere@picknik.ai>
  * Wait for the thread to finish before deleting zmq (#440 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/440>)
    Co-authored-by: JafarAbdi <mailto:cafer.abdi@gmail.com>
  * clang form at
  * clang format
  * new clang format
  * Moving tinyxml2 to 3rdparty
  * Merge branch 'master' of github.com:BehaviorTree/BehaviorTree.CPP
  * backporting changes from v4.x
  * Update README.md
  * fix warnings
  * Merge branch 'master' of github.com:BehaviorTree/BehaviorTree.CPP
  * fix issue #433 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/433>
  * Added ros_environment dependency to make sure ROS_VERSION is initialized (#420 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/420>)
  * Added XML validation for decorators without children (#424 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/424>)
    * Added unit tests to demonstrate failure
    * Added validation that decorators have only one child
  * Update expected-lite to 0.6.2 (#418 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/418>)
  * fix test
  * parallel node fix
  * threshold child count dynamically in parallel control node (#363 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/363>)
  * Adding the reserved word "_description" (#394 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/394>)
  * fix(README): change find_package() instruction for BT external usage (#401 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/401>)
    Co-authored-by: Luca Bonamini <mailto:luca.bonamini@yapemobility.it>
  * Example suggests it's not restricted to a few (#414 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/414>)
    * Example suggests it's not restricted to a few
    * Update delay_node.h
    Fix flow of sentence, milliseconds is already put in specification.
  * documentation and doc correction
  * Merge branch 'master' of github.com:BehaviorTree/BehaviorTree.CPP
  * improve writeTreeNodesModelXML
  * Shutdown zmq context after joining the server thread and flushing (#400 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/400>)
  * Update README.md
  * add option to conditionally build manual selector node (#397 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/397>)
    * add option to conditionally build manual selector node
    * do not fail if BUILD_MANUAL_SELECTOR is true but Curses is not found
  * remove variables that depend on CMAKE_BINARY_DIR being set (#398 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/398>)
    * remove variables that depend on CMAKE_BINARY_DIR being set
    * Update cmake.yml
  * Small comments on node registration (#399 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/399>)
  * Fix destination in CMakeLists.txt (#389 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/389>)
  * Contributors: Adam Sasine, Alberto Soragna, AndyZe, Davide Faconti, Dennis, Gaël Écorchard, Jafar, Joseph Schornak, Luca Bonamini, Paul Bovbel, Tim Clephas, Will

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 10 Oct 2022 22:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.7.0-1bionic) bionic; urgency=high

  * add netlify stuff
  * Event based trigger introduced
    Added a new mechanism to emit "state changed" events that can "wake up" a tree.
    In short, it just provide an interruptible "sleep" function.
  * Fixed bug where including relative paths would fail to find the correct file (#358 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/358>)


=== debian/control ===
Source: ros-melodic-behaviortree-cpp-v3
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libncurses5-dev, libzmq3-dev, ros-melodic-catkin, ros-melodic-ros-environment, ros-melodic-roslib
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-behaviortree-cpp-v3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libncurses5-dev, libzmq3-dev, ros-melodic-roslib
Description: This package provides the Behavior Trees core library.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
